#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_ActivityGrandPrixCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<M_ActivityGrandPrixCFG> M_ActivityGrandPrixCFG::msSingleton(nullptr);

int M_ActivityGrandPrixCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityGrandPrixCFGData* M_ActivityGrandPrixCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_ActivityGrandPrixCFGData>& M_ActivityGrandPrixCFG::GetMapData()
{
	return mMapData;
}

void M_ActivityGrandPrixCFG::Reload()
{
	mMapData.clear();
	Load();
}

void M_ActivityGrandPrixCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityGrandPrixCFGData data;
		data.mID = element->IntAttribute("ID");
		{
			const char* RechangId = element->Attribute("RechangId");
			std::vector<std::string> vecRechangId;
			boost::split(vecRechangId, RechangId, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRechangId.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRechangId[i].c_str(), &temp))
				{
					data.mRechangId.push_back(temp);
				}
			}
		}
		data.mWeight = element->IntAttribute("Weight");
		data.mMultiple = element->IntAttribute("Multiple");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void M_ActivityGrandPrixCFG::Load()
{
	Load("../Config/M_ActivityGrandPrixCFG.xml");
}

M_ActivityGrandPrixCFG* M_ActivityGrandPrixCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityGrandPrixCFG());
	}
	return msSingleton.get();
}
